/*
 * printKeyNames.hpp
 *
 *  Created on: 30.07.2012
 *      Author: heber
 */

#ifndef PRINTKEYNAMES_HPP_
#define PRINTKEYNAMES_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/** Specific namespace for all the specialized template functions that print
 * a useful name for each of the boost::fusion::map key.
 */
namespace printKeyNames {

  /** This function needs to be specialized for every member variable in your
   * boost::fusion::map of values to sum up each such that it prints the name
   * of the member variable.
   *
   * By default, we just return an empty string.
   */
  template <typename T> std::string printName() {
    return std::string();
  };

}

#endif /* PRINTKEYNAMES_HPP_ */
